<?php


function getNetwork($ip){
list( $a, $b, $c, $d ) = split( '\.', $ip );
return $a . "." . $b . "." . $c ;

}

// Función que chequeará si la IP proviene de la universidad de sevilla
// Devolverá true si la IP pertenece al rango de direcciones de la universidad
// de Sevilla
function check_ip($ip){
	//guarda("Entrando");	
	//guarda("-> IP: " . $ip);
	//guarda("-> IP -funcion: " . get_ip());

	$network = getNetwork($ip);
	
	$resultado = false;
	//guarda("-> network: ". $network );
	//echo $network;	
	$f = fopen("/var/consigna/subredes.txt", "r");
	while (!feof($f)) {
	   $buffer = fgets($f, 4096);
	   $buffer = rtrim($buffer,"\n");
	   //echo $buffer;
	   // Si coincide con las líneas del fichero (que son las subredes) 
	   //guarda("Buscando coincidencia con ". $buffer . " Longitud: " . strlen($buffer));
		if (eregi("^" . $buffer ,$network) && strlen($buffer)>0 ){
		    //guarda("** Encontrada coincidencia con " . $buffer);
			fclose($f);
			return true;
		}
	}
	//guarda("No se encontró coincidencia");
	fclose($f);
	return $resultado;

	//guarda("Saliendo");	
}


function se_puede_download($dir, $item) {
	if(($GLOBALS["permissions"]&01)!=01) return 1;
	if(!get_is_file($dir,$item))         return 2;
	if(!get_show_item($dir, $item))      return 3;

	$abs_item = get_abs_item($dir,$item);
	$id=dba_open($GLOBALS["dbfile"],"r","db4");
	if ($id > 0)
	{
		if (dba_exists($abs_item,$id))
		{	
			$ip=$_SERVER["REMOTE_ADDR"];

			$dbline=dba_fetch($abs_item,$id);
			dba_close($id);
			$pass2="";
			if($pos=strpos($dbline,"/"))
			{
				list ($ipbd,$pass2,$labelDBA,$thecreds) = explode ("/", $dbline);
			}

			if( $thecreds != "" || $GLOBALS['__SESSION']["creds"] != "") { return 0; }
			else if (!check_ip($ipbd) && !check_ip($ip)) { return 4; }
		}
		else { return 7; } // dba_exists
	}
	else { return 8; }  // dba_open
}



function luis() {
  echo "\n<hr>\n";
  echo "<b><font color='red'>";
  echo "Los ficheros que suba podr&aacute;n ser bajados ";
  if( $GLOBALS['__SESSION']["creds"]) {
    echo "por cualquiera";
  } else {
    if( check_ip( $_SERVER['REMOTE_ADDR'])) {
      echo "por cualquiera";
    } else {
      echo "desde la red interna o por usuarios autenticados desde cualquier sitio";
    }
  }
  echo "</font></b><br>";

  echo "<b><font color='red'>";
  echo "Puede bajar ";
  if( $GLOBALS['__SESSION']["creds"]) {
    echo "todos los ficheros";
  } else {
    if( check_ip( $_SERVER['REMOTE_ADDR'])) {
      echo "todos los ficheros";
    } else {
      echo "los ficheros subidos desde la red interna o por usuarios autenticados";
    }
  }
  echo "</font></b>";



/* Comentado para el video */
/*
  echo "\n<hr>\n";
  echo "<table border='0'>\n";
  echo "<tr><td>\n";
  echo "<b>Auth MECH:";
  echo $GLOBALS['__SESSION']["auth_mech"];
  echo "</b>-\n";
  echo "<b>CREDS:";
  echo $GLOBALS['__SESSION']["creds"];
  echo "-Sesion Shibboleth:";
  if( $_SERVER['HTTP_SHIB_IDENTITY_PROVIDER'] != "") { echo "SI:".$_SERVER['HTTP_SHIB_IDENTITY_PROVIDER'];}
  else                                                { echo "NO"; }
  echo "</b>\n";
  echo "<br>\n";
  echo "<a href=\"".make_link("auth_sso","")."\">Autentificar con SSO local (PAPI)</a><br>\n";
  echo "<a href=\"".make_link("auth_idp","")."\">Autentificar con IdP local (Shib, lazy)</a><br>\n";
  echo "<a href=\"".make_link("auth_fed","")."\">Autentificar con federacion (Shib, lazy, WAYF)</a><br>\n";
  echo "<a href=''>Autentificar con OpenID</a><br>\n";
  echo "&nbsp;<br>";
  echo "<a href=\"".make_link("logout","")."\">Logout (de la aplic., no del IdP/AS)</a><br>\n";
  echo "<a href=\"".make_link("logout_as","")."\">Logout del AS (en pruebas)</a><br>\n";
  echo "</table>";
*/
}

function check_auth_sso() {
  include 'papi/PoA.php';
  $poa = new PoA('consigna');
  list ($res, $userAssertion) = $poa->check_Access();
  $GLOBALS['__SESSION']["creds"] = $userAssertion;
}

// Manda a un IdP determinado
function check_auth_idp() {
  // Ver si hay credenciales
  if( $_SERVER['HTTP_SHIB_IDENTITY_PROVIDER'] != "") {
    $GLOBALS['__SESSION']["creds"] = $_SERVER['REMOTE_USER'];
  } else {
    header("Location: https://idpucotest.uco.es/shibboleth-idp/SSO?shire=http%3A%2F%2Fsicsis01.uco.es%2Fconsigna%2FShibboleth.sso%2FSAML%2FPOST&time=1184264825&target=cookie&providerId=http%3A%2F%2Fsicsis01.uco.es%2Fshibboleth");
  }
}

// Manda al WAYF configurado para el SP
function check_auth_fed() {
  // Ver si hay credenciales
  if( $_SERVER['HTTP_SHIB_IDENTITY_PROVIDER'] != "") {
    $GLOBALS['__SESSION']["creds"] = $_SERVER['REMOTE_USER']; 
  } else {
    header("Location: http://sicsis01.uco.es/consigna/Shibboleth.sso/WAYF/sicsis01.uco.es?target=http%3A%2F%2Fsicsis01.uco.es%2Fconsigna");
  }
}

function luis_logout() {
  switch( $GLOBALS['__SESSION']["auth_mech"]) {
    case "auth_sso":
      session_destroy();
      // header("Location: https://papias.papi.uco.es/cgi-bin/AuthServer?LOGOUT");
      // echo "<img src='http://papias.papi.uco.es/cgi-bin/AuthServer?LOGOUT'>\n";
      setcookie( "Lcook", "");
      session_destroy();
      header("location: ".$GLOBALS["script_name"]);
      break;
    case "auth_idp":
      session_destroy();
    header("Location: http://sicsis01.uco.es/consigna/Shibboleth.sso/Logout");
      break;
    case "auth_fed":
      session_destroy();
    header("Location: http://sicsis01.uco.es/consigna/Shibboleth.sso/Logout");
      break;
  }
}

function luis_logout_as() {
  session_destroy();
  header("Location: https://papias.papi.uco.es/cgi-bin/AuthServer?LOGOUT");
  exit;
}


function luis_check_access() {
  switch( $GLOBALS['__SESSION']["auth_mech"]) {
    case "auth_sso":
      check_auth_sso();
      break;
    case "auth_idp":
      check_auth_idp();
      break;
    case "auth_fed":
      check_auth_fed();
      break;
  }
}


?>
